#Dim All
#Register None
#Compile Dll
#Option Version4

#Com Doc  "BHO Testversion"
#Com Name "BHOPB", 1.0
#Com Guid Guid$("{0D1ED90F-D995-4A40-AC4A-E1EC3C49F237}")
#Com TLib On

#Include "WIN32API.INC"
#Include "shlwapi.inc"

#Include "BHOPB.inc"

#Include "WebBrowserEvents.bas"

'#RESOURCE "BHOPB.PBR"

'===============================================================================
' IUnknown uuid(00020402-0000-0000-c000-000000000046)
'===============================================================================

'-------------------------------------------------------------------------------
'
' PROCEDURE: IUnknown_QueryInterface
' PURPOSE:   Converts an ANSI string to an OLECHAR string.
' RETURN:    S_OK if the interface is supported, E_NOINTERFACE if it is not.
'
'-------------------------------------------------------------------------------

Function IUnknown_QueryInterface _
  ( _
  ByVal pThis As Dword, _ ' [IN] current interface pointer
        riid  As Guid, _  ' [IN] ID of interface requested
        ppv   As Dword _  ' [OUT] pointer to interface requested
  ) As Long

  Local pVtbl   As IUnknownVtbl Ptr
  Local lpfn    As Dword

  pVTbl = pThis                       ' cast as IUnknown ptr
  lpfn  = @@pVtbl.QueryInterface

  ! push  ppv
  ! mov   eax, riid
  ! push  eax
  ! push  pThis
  ! call  lpfn
  ! mov   FUNCTION, eax       ' HRESULT

End Function

'-------------------------------------------------------------------------------
'
' PROCEDURE: IUnknown_AddRef
' PURPOSE:   Increments an object's reference count, returning the new count.
' RETURN:    The new reference count.
'
'-------------------------------------------------------------------------------

Function IUnknown_AddRef _
  ( _
  ByVal pThis As Dword _  ' [IN] current interface pointer
  ) As Long

  Local pVtbl   As IUnknownVtbl Ptr
  Local lpfn    As Dword

  pVTbl = pThis                       ' cast as IUnknown ptr
  lpfn  = @@pVtbl.AddRef

  ! push  pThis
  ! call  lpfn
  ! mov   FUNCTION, eax       ' HRESULT

End Function

'-------------------------------------------------------------------------------
'
' PROCEDURE: IUnknown_Release
' PURPOSE:   Decrements an object's reference count, returning the new count.
'            If the new count is zero, the object is allowed to (delete,
'            destroy) itself, and the caller must then assume that all interface
'            pointers to the object are invalid.
' RETURN:    The new reference count.
'
'-------------------------------------------------------------------------------

Function IUnknown_Release _
  ( _
  ByVal pThis As Dword _  ' [IN] current interface pointer
  ) As Long

  Local pVtbl   As IUnknownVtbl Ptr
  Local lpfn    As Dword

  pVTbl = pThis                       ' cast as IUnknown ptr
  lpfn  = @@pVtbl.Release

  ! push  pThis
  ! call  lpfn
  ! mov   FUNCTION, eax       ' HRESULT

End Function

'----------------------------------------------------------------------
'
' FUNCTION: ZeroMemoryEx
' PURPOSE:  Fills a block of memory with zeros.
' NOTES:
' RETURNS:
'
'----------------------------------------------------------------------

Sub ZeroMemoryEx _
  ( _
  ByVal lpMem As Dword, _ ' Pointer to the starting address of the block of memory to fill with zeros
  ByVal cb    As Long _   ' Size of the block of memory to fill with zeros, in bytes
  )

  ! mov   edi, lpMem
  ! cmp   edi, 0
  ! je    zmxExit
  ! mov   ecx, cb
zmxFill:
  ! cmp   ecx, 0
  ! je    zmxExit
  ! mov   byte ptr[edi], &H00?
  ! inc   edi
  ! dec   ecx
  ! jmp   zmxFill
zmxExit:

End Sub

'----------------------------------------------------------------------

Class CBHOPB $CLSID_BHOPB As Com

  Instance m_oEvents  As DWebBrowserEvents2

  Class Method Create()

  End Method

  Class Method Destroy()

    Events End m_oEvents

    MsgBox "Class destroyed"

  End Method

  Interface IBHOPB $IID_IBHOPB : Inherit DUAL

    ' Add methods and properties as needed

  End Interface

  Interface IObjectWithSite $IID_IOBJECTWITHSITE As Hidden : Inherit IUnknown

    Method SetSite _
      ( _
      ByVal pUnkSite  As IUnknown _  ' [IN] Pointer to the IUnknown interface pointer of the site managing this object
      ) As Long

      Local sName       As String
      Local oObject     As IUnknown
      Local oBrowser    As IDispatch
      Local riid        As Guid
      Local hr          As Long

      ' We could use our low-level IUnknown_QueryInterface function for this,
      ' but we will use PB's undocumented QueryInterface.
      riid = $IID_IWEBBROWSER2
      hr = pUnkSite.QueryInterface(riid, ByVal VarPtr(oBrowser))
      If IsObject(oBrowser) Then
        ' Late-binding test
        Object Get oBrowser.Name To sName
        MsgBox "Name: " + ACode$(sName)

        ' Connect our sink to the CDWebBrowserEvents2 connection point
        m_oEvents = Class "CDWebBrowserEvents2"

        Events From oBrowser Call m_oEvents
      End If

      Method = %s_ok

    End Method

    Method GetSite _
      ( _
      riid    As Guid, _    ' [IN] The IID of the interface pointer that should be returned in ppvSite
      ppvSite As IUnknown _ ' [OUT] Address of pointer variable that receives the interface pointer requested in riid
      ) As Long

      Method = %e_nointerface

    End Method

  End Interface

End Class

'*** DllRegisterServer

Function DllRegisterServer Alias "DllRegisterServer" () Export As Long

  Local szModule    As Asciiz * 1024
  Local szValue     As Asciiz * 2048
  Local szKey       As Asciiz * %MAX_PATH
  Local szKey2      As Asciiz * %MAX_PATH
  Local lpwsz       As Dword
  Local cbBuf       As Dword
  Local pITypeLib   As Dword
  Local hr          As Long

  ' Obtain the path to this module's executable file for later use.
  GetModuleFileName ghInstance, szModule, SizeOf(szModule)

  ' CLSID key
  ' ---------
  ' Build the key CLSID\{...}
  szKey = "CLSID\"
  lstrcat szKey, GuidTxt$($CLSID_BHOPB)

    ' Add the CLSID to the registry.
  szValue = "BHO"
  SHSetValue %HKEY_CLASSES_ROOT, szKey, ByVal %NULL, %REG_SZ, ByVal VarPtr(szValue), Len(szValue)

    ' Add the server filename subkey under the CLSID key.
  SHSetValue %HKEY_CLASSES_ROOT, szKey + "\InprocServer32", ByVal %NULL, %REG_SZ, ByVal VarPtr(szModule), Len(szModule)

  ' Add the named value, Threading model, to the InprocServer32 subkey.
  szValue = "Apartment"
  SHSetValue %HKEY_CLASSES_ROOT, szKey + "\InprocServer32", "ThreadingModel", %REG_SZ, ByVal VarPtr(szValue), Len(szValue)

  ' Add the Typelib subkey under the CLSID key.
  szValue = GuidTxt$($LIBID_BHOPB)
  SHSetValue %HKEY_CLASSES_ROOT, szKey + "\TypeLib", ByVal %NULL, %REG_SZ, ByVal VarPtr(szValue), Len(szValue)

  ' Add the Version subkey under the CLSID key.
  szValue = "1.0"
  SHSetValue %HKEY_CLASSES_ROOT, szKey + "\Version", ByVal %NULL, %REG_SZ, ByVal VarPtr(szValue), Len(szValue)

  ' Register as a BHO
  szKey = "SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\Browser Helper Objects\"
  lstrcat szKey, GuidTxt$($CLSID_BHOPB)
  SHSetValue %HKEY_LOCAL_MACHINE, szKey, ByVal %NULL, %REG_SZ, ByVal %NULL, 0

  ' Register the type library
  cbBuf = Len(szModule) + 1
  lpwsz = CoTaskMemAlloc(cbBuf + cbBuf)
  If lpwsz Then
    ZeroMemoryEx lpwsz, cbBuf + cbBuf
    MultiByteToWideChar %CP_ACP, 0, ByVal VarPtr(szModule), -1, ByVal lpwsz, cbBuf
    hr = LoadTypeLib(lpwsz, pITypeLib)
    If hr = %s_ok Then
      hr = RegisterTypeLib(pITypeLib, lpwsz, lpwsz)
      IUnknown_Release pITypeLib
    End If
    CoTaskMemFree lpwsz
  End If

  Function = %s_ok

End Function

'*** DllUnregisterServer

Function DllUnregisterServer Alias "DllUnregisterServer" () Export As Long

  Local szKey       As Asciiz * %MAX_PATH

  ' Build the key CLSID\{...}
  szKey = "CLSID\"
  lstrcat szKey, GuidTxt$($CLSID_BHOPB)

 ' Delete the CLSID Key - CLSID\{...}

  SHDeleteKey %HKEY_CLASSES_ROOT, szKey
  szKey = "SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\Browser Helper Objects\"
  lstrcat szKey, GuidTxt$($CLSID_BHOPB)
  SHDeleteKey %HKEY_LOCAL_MACHINE, szKey

  ' Delete the TypeLib key.
  szKey = "TypeLib\"
  lstrcat szKey, GuidTxt$($LIBID_BHOPB)
  SHDeleteKey %HKEY_CLASSES_ROOT, szKey

  Function = %s_ok

End Function

'----------------------------------------------------------------------
'
'   FUNCTION: LibMain()
'   PURPOSE:
'   RETURNS:
'
'----------------------------------------------------------------------

Function LibMain _
  ( _
    ByVal hInstance   As Long, _  ' DLL instance handle
    ByVal fwdReason   As Long, _  ' Why the DLL entry-point is being called
    ByVal lpvReserved As Long _   ' Further aspects of the DLL initialization and cleanup
  ) Export            As Long

  Local szLoader    As Asciiz * %MAX_PATH

  Select Case fwdReason
    Case %DLL_PROCESS_ATTACH
      ' Quit loading if it is Windows Explorer.
      ' Note: A BHO can be called either by Internet Explorer or Windows Explorer
      '       if you're running at least shell version 4.71.
      GetModuleFileName %NULL, szLoader, %MAX_PATH
      If UCase$(szLoader) = "EXPLORER.EXE" Then
        Function = %FALSE
        Exit Function
      End If
      ghInstance = hInstance
      ' We don't need to do any thread initialization
      DisableThreadLibraryCalls hInstance

    Case %DLL_THREAD_ATTACH

    Case %DLL_PROCESS_DETACH

    Case %DLL_THREAD_DETACH
  End Select

  Function = %TRUE

End Function
