Class CDWebBrowserEvents2 $CLSID_DWEBBROWSEREVENTS2 As Event

Interface DWebBrowserEvents2 $IID_DWEBBROWSEREVENTS2 As Event

  Inherit IDispatch

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_StatusTextChange
' PURPOSE:   Statusbar text changed.
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_StatusTextChange <&H00000066> _
  ( _
  ByVal sText   As String _           ' [in]
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_ProgressChange
' PURPOSE:   Fired when download progress is updated.
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_ProgressChange <&H0000006C> _
  ( _
  ByVal Progress    As Long, _            ' [in]
  ByVal ProgressMax As Long _             ' [in]
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_CommandStateChange
' PURPOSE:   The enabled state of a command changed.
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_CommandStateChange <&H00000069> _
  ( _
  ByVal Command As Long, _            ' [in]
  ByVal fEnable As Integer _          ' [in]
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_DownloadBegin
' PURPOSE:   Download of a page started.
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_DownloadBegin <&H0000006A> ()

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_DownloadComplete
' PURPOSE:   Download of page complete.
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_DownloadComplete <&H00000068> ()

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_TitleChange
' PURPOSE:   Document title changed.
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_TitleChange <&H00000071> _
  ( _
  ByVal sText   As String _           ' [in]
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_PropertyChange
' PURPOSE:   Fired when the PutProperty method has been called.
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_PropertyChange <&H00000070> _
  ( _
  ByVal szProperty  As String _           ' [in]
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_BeforeNavigate2
' PURPOSE:   Fired before navigate occurs in the given WebBrowser (window or
'            frameset element). The processing of this navigation may be
'            modified.
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_BeforeNavigate2 <&H000000FA> _
  ( _
  ByVal pDisp           As Dispatch, _        ' [in] IDispatch
        URL             As Variant, _         ' [in]
        Flags           As Variant, _         ' [in]
        TargetFrameName As Variant, _         ' [in]
        PostData        As Variant, _         ' [in]
        Headers         As Variant, _         ' [in]
        fCancel         As Integer _          ' [in,out]
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_NewWindow2
' PURPOSE:   A new, hidden, non-navigated WebBrowser window is needed.
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_NewWindow2 <&H000000FB> _
  ( _
  ppDisp  As Dispatch, _        ' [in,out] IDispatch
  fCancel As Integer _          ' [in,out]
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_NavigateComplete2
' PURPOSE:   Fired when the document being navigated to becomes visible and
'            enters the navigation stack.
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_NavigateComplete2 <&H000000FC> _
  ( _
  ByVal pDisp   As Dispatch, _        ' [in] IDispatch
        URL     As Variant _          ' [in]
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_DocumentComplete
' PURPOSE:   Fired when the document being navigated to reaches
'            ReadyState_Complete.
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_DocumentComplete <&H00000103>_
  ( _
  ByVal pDisp   As Dispatch, _        ' [in] IDispatch
        URL     As Variant _          ' [in]
  )

  MsgBox "DocumentComplete" + $CrLf + Variant$(URL)

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_OnQuit
' PURPOSE:   Fired when application is quiting.
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_OnQuit <&H000000FD> ()

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_OnVisible
' PURPOSE:   Fired when the window should be shown/hidden
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_OnVisible <&H000000FE> _
  ( _
  ByVal nVisible As Integer _          ' [in]
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_OnToolBar
' PURPOSE:   Fired when the toolbar  should be shown/hidden
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_OnToolBar <&H000000FF> _
  ( _
  ByVal nToolbar As Integer _          ' [in]
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_OnMenuBar
' PURPOSE:   Fired when the menubar should be shown/hidden
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_OnMenuBar <&H00000100> _
  ( _
  ByVal MenuBar As Integer _          ' [in]
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_OnStatusBar
' PURPOSE:   Fired when the statusbar should be shown/hidden
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_OnStatusBar <&H00000101> _
  ( _
  ByVal nStatusBar As Integer _          ' [in]
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_OnFullScreen
' PURPOSE:   Fired when fullscreen mode should be on/off
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_OnFullScreen <&H00000102> _
  ( _
  ByVal FullScreen  As Integer _          ' [in]
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_OnTheaterMode
' PURPOSE:   Fired when theater mode should be on/off
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_OnTheaterMode <&H00000104> _
  ( _
  ByVal TheaterMode As Integer _          ' [in]
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_WindowSetResizable
' PURPOSE:   Fired when the host window should allow/disallow resizing
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_WindowSetResizable <&H00000106> _
  ( _
  ByVal Resizable As Integer _          ' [in]
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_WindowSetLeft
' PURPOSE:   Fired when the host window should change its Left coordinate
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_WindowSetLeft <&H00000108> _
  ( _
  ByVal lLeft   As Long _             ' [in]
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_WindowSetTop
' PURPOSE:   Fired when the host window should change its Top coordinate
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_WindowSetTop <&H00000109> _
  ( _
  ByVal Top     As Long _             ' [in]
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_WindowSetWidth
' PURPOSE:   Fired when the host window should change its width
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_WindowSetWidth <&H0000010A> _
  ( _
  ByVal lWidth  As Long _             ' [in]
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_WindowSetHeight
' PURPOSE:   Fired when the host window should change its height
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_WindowSetHeight <&H0000010B> _
  ( _
  ByVal Height  As Long _             ' [in]
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_WindowClosing
' PURPOSE:   Fired when the WebBrowser is about to be closed by script
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_WindowClosing <&H00000107> _
  ( _
  ByVal IsChildWindow As Integer, _         ' [in]
        fCancel       As Integer _          ' [in,out]
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_ClientToHostWindow
' PURPOSE:   Fired to request client sizes be converted to host window sizes
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_ClientToHostWindow <&H0000010C> _
  ( _
  CX      As Long, _            ' [in,out]
  CY      As Long _             ' [in,out]
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_SetSecureLockIcon
' PURPOSE:   Fired to indicate the security level of the current web page
'            contents
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_SetSecureLockIcon <&H0000010D> _
  ( _
  ByVal SecureLockIcon  As Long _             ' [in]
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_FileDownload
' PURPOSE:   Fired to indicate the File Download dialog is opening
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_FileDownload <&H0000010E> _
  ( _
  ByVal ActiveDocument  As Integer, _         ' [in]
        fCancel         As Integer _          ' [in,out]
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_NavigateError
' PURPOSE:   Fired when a binding error occurs (window or frameset element).
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_NavigateError <&H0000010F>_
  ( _
  ByVal pDisp       As Dispatch, _        ' [in] IDispatch
        URL         As Variant, _         ' [in]
        vFrame      As Variant, _         ' [in]
        StatusCode  As Variant, _         ' [in]
        fCancel     As Integer _          ' [in,out]
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_PrintTemplateInstantiation
' PURPOSE:   Fired when a print template is instantiated.
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_PrintTemplateInstantiation <&H000000E1> _
  ( _
  ByVal pDisp   As Dispatch _         ' [in] IDispatch
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_PrintTemplateTeardown
' PURPOSE:   Fired when a print template destroyed.
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_PrintTemplateTeardown <&H000000E2> _
  ( _
  ByVal pDisp   As Dispatch _         ' [in] IDispatch
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_UpdatePageStatus
' PURPOSE:   Fired when a page is spooled. When it is fired can be changed by a
'            custom template.
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_UpdatePageStatus <&H000000E3> _
  ( _
  ByVal pDisp   As Dispatch, _        ' [in] IDispatch
        nPage   As Variant, _         ' [in]
        fDone   As Variant _          ' [in]
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_PrivacyImpactedStateChange
' PURPOSE:   Fired when the global privacy impacted state changes
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_PrivacyImpactedStateChange <&H00000110> _
  ( _
  ByVal bImpacted As Integer _          ' [in]
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_NewWindow3
' PURPOSE:   A new, hidden, non-navigated WebBrowser window is needed.
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_NewWindow3 <&H00000111> _
  ( _
        ppDisp          As Dispatch, _        ' [in,out] IDispatch
        fCancel         As Integer, _         ' [in,out]
  ByVal dwFlags         As Dword, _           ' [in]
  ByVal bstrUrlContext  As String, _          ' [in]
  ByVal bstrUrl         As String _           ' [in]
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_SetPhishingFilterStatus
' PURPOSE:   Fired to indicate the progress and status of the Phishing Filter
'            analysis of the current web page
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_SetPhishingFilterStatus <&H0000011A> _
  ( _
  ByVal PhishingFilterStatus  As Long _             ' [in]
  )

End Method

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WebBrowser1_WindowStateChanged
' PURPOSE:   Fired to indicate that the browser window's visibility or enabled
'            state has changed.
'
'-------------------------------------------------------------------------------

Method Form1_WebBrowser1_WindowStateChanged <&H0000011B> _
  ( _
  ByVal dwWindowStateFlags  As Dword, _           ' [in]
  ByVal dwValidFlagsMask    As Dword _            ' [in]
  )

End Method

End Interface

End Class
